Function LoadManifest(ManifestFile$)
	
	local Label$=""
	local ManifestFile_Buffer$=""
	
	;capture manifest filename
	;ManifestFile$=ManifestFile$
	;validate manifest
	select false
	case is_file(".\datapack\manifests\"+ManifestFile$+".txt")
		return
	end select
	;open manifest
	FileIn(2)=OpenFile(".\datapack\manifests\"+ManifestFile$+".txt")
	;while lines are available
	
	objNearDistance#(objIndex,ndVd)=-2
	objNearDistance#(objIndex,ndVtt)=-2
	objNearDistance#(objIndex,ndVdist)=-1

	While Not(Eof(FileIn(2)))
		;read line buffer from manifest file
		ManifestFile_Buffer$=ReadLine$(FileIn(2))
		;parse line label
		
		Label$=Prefix$(ManifestFile_Buffer$,":")
		ManifestFile_Buffer$=Suffix$(ManifestFile_Buffer$,":")

		select true
		
		case Label$="docket"
			objIndex=s2i(ManifestFile_Buffer$)
		
		case Label$="class"
			objClass$(objIndex)=ManifestFile_Buffer$
		
		case Label$="name"
			objName$(objIndex)=ManifestFile_Buffer$
		
		case Label$="image"
			objImageName$(objIndex)=ManifestFile_Buffer$
		
		case Label$="logic"
			objLogic$(objIndex)=ManifestFile_Buffer$
		
		case AxisLabel$(Label$)="encounter"
			
			select true
			case AxisParam$(Label$)="1"
				objEncounter1$(objIndex)=ManifestFile_Buffer$
			case AxisParam$(Label$)="2"
				objEncounter2$(objIndex)=ManifestFile_Buffer$
			end select
		
		case Label$="pace"
			objPace$(objIndex)=ManifestFile_Buffer$
		
		case Label$="logic"
			objLogic$(objIndex)=ManifestFile_Buffer$
		
		case AxisLabel$(Label$)="near"
			
			select true			
			case AxisParam$(Label$)="d#"
				
				select true
				case len(ManifestFile_Buffer$)>0
					objNearDistance#(objIndex,ndVd)=s2f(ManifestFile_Buffer$)
				default
					objNearDistance#(objIndex,ndVd)=-2
				end select
			
			case AxisParam$(Label$)="tt"
				
				select true
				case len(ManifestFile_Buffer$)>0
					objNearDistance#(objIndex,ndVtt)=s2f(ManifestFile_Buffer$)
				default
					objNearDistance#(objIndex,ndVtt)=-2
				end select
			
			case AxisParam$(Label$)="distd#"
				
				select true
				case len(ManifestFile_Buffer$)>0
					objNearDistance#(objIndex,ndVdist)=s2f(ManifestFile_Buffer$)^2
				default
					objNearDistance#(objIndex,ndVdist)=-1
				end select

			end select
			
		end select
		
		;docket sprite
		
	Wend
;;;objNearDistance#	
	
	objImageName$(objIndex)=".\datapack\img\"+objClass$(objIndex)+"\"+objImageName$(objIndex)

	select true
	case is_file(objImageName$(objIndex))
		objSprite(objIndex,0)=LoadImage(objImageName$(objIndex))
	default
		objSprite(objIndex,0)=CreateImage(32,32)
	End select
	
	MaskImage objSprite(objIndex,0),255,0,255
	MidHandle objSprite(objIndex,0)
	
	objSprite(objIndex,1)=copyimage(objSprite(objIndex,0))
	resizeimage objSprite(objIndex,1),32,32

	objSprite(objIndex,2)=copyimage(objSprite(objIndex,0))
	resizeimage objSprite(objIndex,2),16,16
	
	IniEncounters(objIndex,objEncounter1$(objIndex),1)
	IniEncounters(objIndex,objEncounter2$(objIndex),2)
	
	IniPace(objIndex)

	Dump_Manifest(objIndex,true)
		
	CloseFile FileIn(2)
End Function
