function render_hud()	
	
	t=obj#(comsat,5)
	If t>0 Then
		rx#=obj#(t,objVX)-x#+sx#
		ry#=obj#(t,objVY)-y#+sy#
		imgTemp=objSprite(f2i(obj#(t,objVName)),0)
		if imgTemp<>0 then
			xr#=ImageWidth(imgTemp)/2
			yr#=ImageHeight(imgTemp)/2
		else
			xr#=32
			yr#=32
		endif
		If rx#-xr#>swc-16 Then
			rx#=swc
			xr#=16
			yr#=16
		EndIf
		If rx#+xr#<-swc+16 Then
			rx#=-swc
			xr#=16
			yr#=16
		EndIf
		If ry#-yr#>shc-16 Then
			ry#=shc
			xr#=16
			yr#=16
		EndIf
		If ry#+yr#<-shc+16 Then
			ry#=-shc
			xr#=16
			yr#=16
		EndIf
		x1#=swc+rx#-xr#
		y1#=shc+ry#-yr#
		x2#=swc+rx#+xr#
		y2#=shc+ry#+yr#
		Color 255,128,0
		Rect x1#,y1#,xr#*2,yr#*2,0
	EndIf
	t=comsat
	rx#=obj#(t,objVX)-x#+sx#
	ry#=obj#(t,objVY)-y#+sy#
	imgTemp=objSprite(f2i(obj#(t,objVName)),0)
	if imgTemp<>0 then
		xr#=ImageWidth(imgTemp)/2
		yr#=ImageHeight(imgTemp)/2
	else
		xr#=32
		yr#=32
	endif
	If rx#-xr#>swc-16 Then
		rx#=swc
		xr#=16
		yr#=16
	EndIf
	If rx#+xr#<-swc+16 Then
		rx#=-swc
		xr#=16
		yr#=16
	EndIf
	If ry#-yr#>shc-16 Then
		ry#=shc
		xr#=16
		yr#=16
	EndIf
	If ry#+yr#<-shc+16 Then
		ry#=-shc
		xr#=16
		yr#=16
	EndIf
	x1#=swc+rx#-xr#
	y1#=shc+ry#-yr#
	x2#=swc+rx#+xr#
	y2#=shc+ry#+yr#
	Color 0,255,0
	Rect x1#,y1#,xr#*2,yr#*2,0
	
end function

function pace_hud(t)
	
	local POI=0
	local PaceIndex=0
	
	repeat
		
		select false
		case t>=1
			exit
		case t<=VesselMx
			exit
		case PaceIndex>=0
			exit
		case PaceIndex<=PaceMx
			exit
		;case objPaceDistance#(f2i(obj#(t,objVName)),PaceIndex)>-1
		;	exit
		end select
		
		select false
		case f2i(objPacePace#(f2i(obj#(t,objVName)),PaceIndex))=-1
			
		color 255,255,255
		text 520,POI*32+32,"Pace:"+i2s$(PaceIndex)+" ("+f2s$(objPaceDistance#(f2i(obj#(t,objVName)),PaceIndex))+"/"+f2s$(objPacePace#(f2i(obj#(t,objVName)),PaceIndex))+")",true,true

			POI=POI+1
			
		end select

		PaceIndex=PaceIndex+1

	forever
end function

function Encounters_hud(t,list)

	local EIndex=0
	local ETT$=""
	local ETO$=""
	local ETI=-1
	local EOI=0
	
	select false
	case list=>1 and list<=2
		return
	end select
	
	repeat
		
		select false
		case t>=0
			exit
		case t<=ShipMx
			exit
		case EIndex>=0
			exit
		case EIndex<=ShipMx
			exit
		end select
		
		ETT$=""
		ETO$=""
		
		select list
		case 1
			ETI=objEncounters1(t,EIndex)
		case 2
			ETI=objEncounters2(t,EIndex)
		default
			exit
		end select
		
		ETO$=objName$(EIndex)

		select list
		case 1
			ETT$=ETT$+"Chase:"
		case 2
			ETT$=ETT$+"Co-Op:"
		end select
			
		ETT$=ETT$+i2s$(ETI)
		ETT$=ETT$+": "
		ETT$=ETT$+i2s$(EIndex)
		ETT$=ETT$+" ("
		ETT$=ETT$+ETO$
		ETT$=ETT$+")"
				
		EIndex=EIndex+1		
		
		select false
		case ETI=-1
			
			color 255,255,255
			text 280,EOI*16+200*(list-1)+64,ETT$,true,true

			EOI=EOI+1
			
		end select
		
	forever
end function

Function render_comlink()
	
	local Lunit#=0.0
	local opd#=0.0
	local opp#=0.0
	local L$=""
	local D$=""
	local C$=""
	
	Color 0,255,0
	Line swc+sx#,shc+sy#,swc+obj#(comsat,objVX)-x#+sx#,shc+obj#(comsat,objVY)-y#+sy#
	Text 64,64,"comlink #"+i2s$(comsat)+":"+objName$(f2i(obj#(comsat,objVName)))
	
	drawimage objSprite(f2i(obj#(comsat,objVName)),2),64-16,64+8
	
	L$=""
	D$=""
	C$=""
	
	if obj#(comsat,objVSpdX)<>0.0 and obj#(comsat,objVSpdY)<>0.0 then
		
		opd#=objPaceDistance#(comsat,f2i(obj#(comsat,objVPace)))
		opp#=objPacePace#(comsat,f2i(obj#(comsat,objVPace)))
		
		Lunit#=f2s$((obj#(comsat,objVSpdX)^2.0+obj#(comsat,objVSpdY))^2.0)^0.5)
		L$=L$+"ord("
		L$=L$+f2s$(obj#(comsat,objVX)/Lunit#)
		L$=L$+","
		L$=L$+f2s$(obj#(comsat,objVY)/Lunit#)
		L$=L$+")"
		L$=L$+" vel("
		L$=L$+f2s$((obj#(comsat,objVSpdX)^2.0+obj#(comsat,objVSpdY)^2.0)^0.5*opp#
		L$=L$+")"		
	else
		L$=L$+"ord("
		L$=L$+f2s$(obj#(comsat,objVX))
		L$=L$+","
		f2s$(obj#(comsat,objVY))
		L$=L$+")"
	end if
	Text 64,128,L$,true,true

	D$="delta("
	D$=D$+f2s$(obj#(comsat,objVX)-x#)
	D$=D$+","
	D$=D$+f2s$(obj#(comsat,objVY)-y#)
	D$=D$+") dis:"
	D$=D$+f2s$(((obj#(comsat,objVX)-x#)^2.0+(obj#(comsat,objVY)-y#)^2.0)^0.5)

	Text 64,196,D$

	pace_hud(comsat)
	Encounters_hud(f2i(obj#(comsat,objVName)),1)
	Encounters_hud(f2i(obj#(comsat,objVName)),2)
	
	If obj#(comsat,objVChase)>0 Then

		C$="chase #"
		C$=C$+f2s$(obj#(comsat,objVChase))
		C$=C$+":"
		C$=C$+objName$(f2i(obj#(f2i(obj#(comsat,objVChase)),objVName)))
		C$=C$+" dis:"
		C$=C$+f2s$(((obj#(f2i(obj#(comsat,objVChase)),objVX)-x#)^2.0+(obj#(f2i(obj#(comsat,objVChase)),objVX)-y#)^2.0)^0.5)
		
		Color brightness#,Int(brightness#*0.5),0
		Text 64,256,C$
		
		Color brightness#,Int(brightness#*0.5),0
		Line swc+obj#(comsat,objVX)-x#+sx#,shc+obj#(comsat,objVY)-y#+sy#,swc+obj#(f2i(obj#(comsat,objVChase)),objVX)-x#+sx#,shc+obj#(f2i(obj#(comsat,objVChase)),objVY)-y#+sy#
		
		Color brightness#,brightness#,0
		Line swc+sx#,shc+sy#,swc+obj#(f2i(obj#(comsat,objVChase)),objVX)-x#+sx#,shc+obj#(f2i(obj#(comsat,objVChase)),objVY)-y#+sy#
	EndIf
	
	Color 255,0,255
	If md1=1 Then
		Color 255,0,0
	EndIf
	
	Line mx#-32,my#,mx#+32,my#
	Line mx#,my#-32,mx#,my#+32

end function
